# ory_oathkeeper_client (EXPERIMENTAL)
ORY Oathkeeper is a reverse proxy that checks the HTTP Authorization for validity against a set of rules. This service uses Hydra to validate access tokens and policies.

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.40.6
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen
For more information, please visit [https://www.ory.am](https://www.ory.am)

## Requirements

* Dart 2.15.0+ or Flutter 2.8.0+
* Dio 5.0.0+ (https://pub.dev/packages/dio)

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  ory_oathkeeper_client: 0.40.6
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  ory_oathkeeper_client:
    git:
      url: https://github.com/ory/sdk.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  ory_oathkeeper_client:
    path: /path/to/ory_oathkeeper_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_oathkeeper_client/ory_oathkeeper_client.dart';


final api = OryOathkeeperClient().getApiApi();

try {
    api.decisions();
} catch on DioError (e) {
    print("Exception when calling ApiApi->decisions: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*ApiApi*](doc/ApiApi.md) | [**decisions**](doc/ApiApi.md#decisions) | **GET** /decisions | Access Control Decision API
[*ApiApi*](doc/ApiApi.md) | [**getRule**](doc/ApiApi.md#getrule) | **GET** /rules/{id} | Retrieve a Rule
[*ApiApi*](doc/ApiApi.md) | [**getWellKnownJSONWebKeys**](doc/ApiApi.md#getwellknownjsonwebkeys) | **GET** /.well-known/jwks.json | Lists Cryptographic Keys
[*ApiApi*](doc/ApiApi.md) | [**listRules**](doc/ApiApi.md#listrules) | **GET** /rules | List All Rules
[*HealthApi*](doc/HealthApi.md) | [**isInstanceAlive**](doc/HealthApi.md#isinstancealive) | **GET** /health/alive | Check alive status
[*HealthApi*](doc/HealthApi.md) | [**isInstanceReady**](doc/HealthApi.md#isinstanceready) | **GET** /health/ready | Check readiness status
[*VersionApi*](doc/VersionApi.md) | [**getVersion**](doc/VersionApi.md#getversion) | **GET** /version | Get service version


## Documentation For Models

 - [GenericError](doc/GenericError.md)
 - [HealthNotReadyStatus](doc/HealthNotReadyStatus.md)
 - [HealthStatus](doc/HealthStatus.md)
 - [JsonWebKey](doc/JsonWebKey.md)
 - [JsonWebKeySet](doc/JsonWebKeySet.md)
 - [Rule](doc/Rule.md)
 - [RuleHandler](doc/RuleHandler.md)
 - [RuleMatch](doc/RuleMatch.md)
 - [Upstream](doc/Upstream.md)
 - [Version](doc/Version.md)


## Documentation For Authorization

Endpoints do not require authorization.


## Author

hi@ory.am

